;XBOX REMOTE FIRMWARE V1.1 (c) David Mills 2006

;WORKING AND OUTPUTTING THREE BYTES BUT THERE IS SOME REVERSING GOING ON
;WORKING WITH 1/4 SEC PULSE ON GPIO1
;Working in xbox




	LIST      P=12F675       ; LIST DIRECTIVE TO DEFINE PROCESSOR
	#INCLUDE "P12F675.INC"    ; PROCESSOR SPECIFIC VARIABLE DEFINITIONS

	__CONFIG  _CP_OFF & _WDT_OFF & _BODEN_OFF & _PWRTE_OFF & _INTRC_OSC_NOCLKOUT & _MCLRE_OFF & _CPD_OFF

;;0101 0010 1010	;DIPLAY
;
;0101 0000 1000	;MENU
;0101 0001 0101	;PLAY
;0101 0001 1001	;PAUSE
;0101 0001 1010	;TITLE
;0101 0001 1100	;FORWARD
;0101 0001 1101	;REVERS
;0101 0001 1111	;STOP
;0101 0010 0000	;SKIP+
;0101 0010 0010	;SKIP-
;0101 0010 0111	;BACK

;0101 0010 1010	;DIPLAY

;0101 0011 0000	;ZERO
;0101 0011 0001	;ONE
;0101 0011 0010	;TWO
;0101 0011 0011	;THREE
;0101 0011 0100	;FOUR
;0101 0011 0101	;FIVE
;0101 0011 0110	;SIX
;0101 0011 0111	;SEVEN
;0101 0011 1000	;EIGHT
;0101 0011 1001	;NINE
;0101 0011 1100	;INFO
;0101 0101 0110	;LEFT ARROW
;0101 0101 0111	;RIGHT ARROW
;0101 0101 1000	;DOWN ARROW
;0101 0101 1001	;UP ARROW
;0101 1111 0100	;SELECT


;******************************************************************************
;DEFINES
;******************************************************************************
#DEFINE	BANK1		BANKSEL 0X80	;SELECT BANK1
#DEFINE	BANK0		BANKSEL 0X00	;SELECT BANK0

;******************************************************************************
;GENERAL PURPOSE REGISTERS (GPR'S) 
;******************************************************************************
DATA_STATE			EQU	H'00'		

						;BIT IS EITHER TOO LONG OR TOO SHORT (INCL START)
DATA_BAD			EQU H'10'	;MOVE DATA BAD VALUE TO W
_ZERO                           EQU H'0002'
CARRY                        	EQU H'0000'
IR_PORT				EQU GPIO

	CBLOCK	0X20		;START OF GENERAL PURPOSE REGISTERS
	FLAGS
	COUNT			;USED IN LOOPING ROUTINES
	COUNT1			;USED IN DELAY ROUTINE
	COUNTA			;USED IN DELAY ROUTINE
	COUNTB			;USED IN DELAY ROUTINE
	COUNTC
	COUNTD
	BYTE_OUT
	BYTE_IN_LOW		;
	BYTE_IN_HIGH		;
	BYTE_IN_HIGHER		;
	BYTE_IN_LOW1		;
	BYTE_IN_HIGH1		;
	BYTE_IN_HIGHER1		;
	TEMP_TMR1L
	TEMP_TMR1H
	DATA_BIT
	MSEC_TIMER
	W_TEMP
	STATUS_TEMP
	Q_SEC_TIMER


	ENDC

GPI0		EQU 0X05
IR_IN		EQU	0X04			;INPUT ASSIGNMENT FOR IR DATA
LED		EQU	0X05
TPIN		EQU	0X02

;*****************************
	ORG	0X0000
;*****************************
	GOTO	START
;*****************************
       	ORG     0X0004
SERVICE_INT
        MOVWF           W_TEMP          ;COPY W TO W TEMP REG
        SWAPF           STATUS,W        ;SWAP STATUS INTO W
        MOVWF           STATUS_TEMP     ;SAVE IN TEMP STATUS
                                        ;STATUS AND W ARE NOW SAVED
        BTFSS           INTCON,T0IF     ;TIMER 0 INTERRUPT?       
        GOTO            EXIT_INTERUPT   ;NO,EXIT SUB
        
SERVICE_TIMER0

        DECFSZ          MSEC_TIMER,F    ;DECREASE MILL SEC TIMER SKIP IF OUT
        GOTO            EXIT_INTERUPT   ;LEAVE SUB
        MOVLW           D'1'          ;VALUE FOR NEXT 1/4 SECOND
        MOVWF           MSEC_TIMER      ;RESET FOR NEXT 1/4 SECOND
        
        MOVLW           B'00000100'     ;MASK FOR PROGRAM LED
        XORWF           GPI0,F        ;YES, TOGGLE LED
        
EXIT_INTERUPT
        MOVLW           B'00100000'     ;MOVE VALUE TO W TO CLEAR
        MOVWF           INTCON          ;ALL OTHER INTERRUPTS
        SWAPF           STATUS_TEMP,W   ;MOVE STATUS BACK TO W
        MOVWF           STATUS          ;AND BACK TO STATUS
        SWAPF           W_TEMP,F        ;SWAP W_TEMP
        SWAPF           W_TEMP,W        ;AND LOAD INTO W
        RETFIE                          ;RETURN FROM INTERUPT
;***************************************************************************    


;*****************************
;INITIALIZATION
;*****************************
START					;START OF SETUP
;*****************************
;******************************************************************************
	BANK1				; BANK1
;******************************************************************************
	CALL    0X3FF       		; RETRIEVE FACTORY CALIBRATION VALUE
	MOVWF   OSCCAL      		; UPDATE REGISTER WITH FACTORY CAL VALUE
;******************************************************************************
	BSF		PIE1,TMR1IE	;ENABLE THE TIMER 1 INT
;******************************************************************************
    	MOVLW           B'00000000'     ;MASK FOR ANSEL (ADC SELECT)
        MOVWF           ANSEL           ;MAKE ALL I/O DIGITAL
;******************************************************************************
;		SET UP PORT
;******************************************************************************
;                 76543210  
	MOVLW	B'00010000'		; 5-1 INPUTS GP0 OUTPUT
	MOVWF	TRISIO			;


        MOVLW   B'0000010'     		;MOVE PRESCALER OF 1:8 TO W
        MOVWF	OPTION_REG              ;MOVE TO OPTION REG (ENABLE PULL UPS)
;******************************************************************************
	BANK0				; BANK0
;******************************************************************************
	MOVLW	H'07'		;VALUE TO TURN OFF COMPARATORS
	MOVWF	CMCON		;TURN OFF COMPARATORS	
	clrwdt 			;Clear WDT
	clrf 	TMR0 			;Clear TMR0 and
	MOVLW	B'0110001'	;MASK FOR TIMER1
	MOVWF	T1CON		;MOVE TO TIMER 1 CONTROL
					;PRESCALE 1:8
					;TURN TIMER OFF
	BSF	INTCON,GIE	;DISABLE INTS
        BSF     INTCON,T0IE     ;DISABLE TIMER INTERRUPT
;******************************************************************************
; SET UP AND NOW READ FOR MAIN CODE
;********************************************************************
INITIALISE	
	CLRF 	GPIO		;
	BSF	GPIO,1
	BSF	INTCON,GIE	;DISABLE INTS
	CLRF	FLAGS		;
	CLRF	COUNT		;USED IN LOOPING ROUTINES
	CLRF	COUNT1		;USED IN DELAY ROUTINE
	CLRF	COUNTA		;USED IN DELAY ROUTINE
	CLRF	COUNTB		;USED IN DELAY ROUTINE
	CLRF	BYTE_IN_LOW	;
	CLRF	BYTE_IN_HIGH	;
	CLRF	BYTE_IN_HIGHER	;
	CLRF	TMR0		;
	BCF	INTCON,T0IF	;
	BCF	GPIO,LED	;
;******************************************************************************
;	set so pulse on scope can be watched
;******************************************************************************
FIND_START1
	CALL	START_OUTPUT  	;SEND A PLUSE TO WATCH
				;SMALL BIG BIG SMALL
	CALL	START_OUTPUT  	;SEND A PLUSE TO WATCH
				;SMALL BIG BIG SMALL
	CALL	START_OUTPUT  	;SEND A PLUSE TO WATCH
				;SMALL BIG BIG SMALL
FIND_START
	BTFSc	GPIO,IR_IN	;TEST IR IF HIGH
	GOTO	FIND_START	;
	BCf	GPIO,LED	;
	CLRF	TMR1L		;
	CLRF	TMR1H		;
	BCF	PIR1,TMR1IF	;
	CALL 	FIND_START_BIT	;IF RIGHT LED SHOULD FOLLOW IR.
				;ERROR FOR SHORT IS A
				;
ONE_ZEROT			;
	BTFSc	PIR1,TMR1IF	;HAS IT OVER FLOWED
	GOTO 	OVERFLOWED	;
	BTFSc	GPIO,IR_IN	;TEST IR IF HIGH
	GOTO	ONE_ZEROT	;

	CALL	GET_GAP		;


;***************************************************************************
	CALL	GET_DATA_PACKET		;SAVE DATA FROM INFARED
;***************************************************************************
;***************************************************************************
;***************************************************************************
;
;	GOT THREE BYTES BUT THEY ARE IN REVERSE ORDER
;
;***************************************************************************
;***************************************************************************
;***************************************************************************

	CALL	SEND_BYTES		;


	call end_pulse_output		;this checks for Display button and sends high low pluse

	GOTO FIND_START1
;***************************************************************************


SEND_BYTES
	CALL	SEND_GAP1
	MOVF	BYTE_IN_LOW,W
	MOVWF	BYTE_OUT
	CALL	OUTPUT_BYTE
	MOVF	BYTE_IN_HIGH,W
	MOVWF	BYTE_OUT
	CALL	OUTPUT_BYTE
	MOVF	BYTE_IN_HIGHER,W
	MOVWF	BYTE_OUT
	CALL	OUTPUT_BYTE
	RETURN
;***************************************************************************

OUTPUT_BYTE

	MOVLW	D'08'
	MOVWF	COUNTC

        BCF             STATUS,CARRY    ;CLEAR CARRY
LOOP_BIT_OUT
        RLF             BYTE_OUT,F      ;SHIFT OUTPUT BYTE THRO CARRY
        BTFSS           STATUS,CARRY    ;CARRY SET?
	CALL		SEND_0
        BTFSC           STATUS,CARRY    ;CARRY CLEAR?
	CALL		SEND_1
        DECFSZ          COUNTC,F     ;ALL BITS OUT?
        GOTO            LOOP_BIT_OUT    ;NO, LOOP UNTIL FINISHED
	CALL	SEND_GAP1
	RETURN
;***************************************************************************


GET_DATA_PACKET
	MOVLW	D'08'
	MOVWF	COUNTC


LOOP_BIT
	CALL	ONE_ZERO
	BCF		STATUS,CARRY	;CLEAR CARRY
	RRF		DATA_BIT,F	;ROTATE TEMP TIMER1 HIGH (/2)
	RRF		BYTE_IN_LOW,F
	CALL 	GET_GAP

        DECFSZ          COUNTC,F     ;ALL BITS OUT?
        GOTO            LOOP_BIT   ;NO, LOOP UNTIL FINISHED
	CALL	SEND_GAP

	MOVLW	D'08'
	MOVWF	COUNTC
LOOP_BIT1
	CALL	ONE_ZERO
	BCF		STATUS,CARRY	;CLEAR CARRY
	RRF		DATA_BIT,F	;ROTATE TEMP TIMER1 HIGH (/2)
	RRF		BYTE_IN_HIGH,F
	CALL 	GET_GAP

        DECFSZ          COUNTC,F     ;ALL BITS OUT?
        GOTO            LOOP_BIT1   ;NO, LOOP UNTIL FINISHED
	CALL	SEND_GAP

	MOVLW	D'08'
	MOVWF	COUNTC
LOOP_BIT2
	CALL	ONE_ZERO
	BCF		STATUS,CARRY	;CLEAR CARRY
	RRF		DATA_BIT,F	;ROTATE TEMP TIMER1 HIGH (/2)
	RRF		BYTE_IN_HIGHER,F
	CALL 	GET_GAP

        DECFSZ          COUNTC,F     ;ALL BITS OUT?
        GOTO            LOOP_BIT2   ;NO, LOOP UNTIL FINISHED
	CALL	SEND_GAP
	RETURN

;***************************************************************************
;
;***************************************************************************

;***************************************************************************
;
;***************************************************************************
ONE_ZERO
	BTFSc	PIR1,TMR1IF	;HAS IT OVER FLOWED
	GOTO 	OVERFLOWED	;
	BTFSc	GPIO,IR_IN	;TEST IR IF HIGH
	GOTO	ONE_ZERO	;
	BSf	GPIO,LED	;
				;
				;
	MOVF	TMR1L,W		;MOVE TIMER 1 LOW TO W
	MOVWF	TEMP_TMR1L	;STORE IN TEMP TIMER 1 LOW
				;
	CLRF	TMR1L		;RESET TIMER1 LOW
				;
	MOVF	TMR1H,W		;MOVE TIMER1
	MOVWF	TEMP_TMR1H	;STORE IN TEMP TIMER 1 HIGH 1
				;
	CLRF	TMR1H		;RESET TIMER1 LOW
				;
	BCF	STATUS,CARRY	;CLEAR CARRY
	RRF	TEMP_TMR1H,F	;ROTATE TEMP TIMER1 HIGH (/2)
	RRF	TEMP_TMR1L,F	;ROTATE TEMP TIMER1 LOW (/2)
				;
				;
	MOVLW	D'20'		;
	SUBWF	TEMP_TMR1L,W	;SUBTRACT FROM TEMP TIMER1 LOW
				;
	BTFSS	STATUS,CARRY	;CARRY SET?
	GOTO	OVERFLOWED	;LONG LOW THEN 3 SLALL PLUSES
				;
	MOVLW	D'50'		;MOVE D'47' TO W (1504US, UPPER LIMIT OF "0" BIT)
	SUBWF	TEMP_TMR1L,W	;SUBTRACT FROM TEMP TIMER1 LOW
				;
	BTFSS	STATUS,CARRY	;CARRY SET?
	GOTO	OVERFLOWED	;LONG LOW THEN 3 SLALL PLUSES
	CLRF	DATA_BIT	;
				;
	MOVLW	D'100'		;MOVE D'47' TO W (1504US, UPPER LIMIT OF "0" BIT)
	SUBWF	TEMP_TMR1L,W	;SUBTRACT FROM TEMP TIMER1 LOW
				;
	BTFSC	STATUS,CARRY	;CARRY SET?
	RETURN			;
	BSF	DATA_BIT,0	;
	RETURN			;
				;
;***************************************************************************
;
;***************************************************************************
GET_GAP
	BTFSC	PIR1,TMR1IF	;HAS IT OVER FLOWED
	GOTO 	OVERFLOWED	;TIMED OUT DO A RESTART
	BTFSs	GPIO,IR_IN	;TEST IR STILL LOW
	GOTO	GET_GAP		;YES STILL LOW DO AGAIN
	BCf	GPIO,LED	;NO IR CHANGED CHECK TIMES
				;
	MOVF	TMR1L,W		;MOVE TIMER 1 LOW TO W
	MOVWF	TEMP_TMR1L	;STORE IN TEMP TIMER 1 LOW
				;
	CLRF	TMR1L		;RESET TIMER1 LOW
				;
	MOVF	TMR1H,W		;MOVE TIMER1
	MOVWF	TEMP_TMR1H	;STORE IN TEMP TIMER 1 HIGH 1
				;
	CLRF	TMR1H		;RESET TIMER1 LOW
				;
	BCF	STATUS,CARRY	;CLEAR CARRY
	RRF	TEMP_TMR1H,F	;ROTATE TEMP TIMER1 HIGH (/2)
	RRF	TEMP_TMR1L,F	;ROTATE TEMP TIMER1 LOW (/2)
				;
				;
	MOVLW	D'20'		;
	SUBWF	TEMP_TMR1L,W	;SUBTRACT FROM TEMP TIMER1 LOW
				;
	BTFSS	STATUS,CARRY	;CARRY SET?
	GOTO	UNDERFLOWED	;LONG LOW 2 SMALL PLUSESNO, BIT TO SMALL, GOTO BIT BAD
				;
	MOVLW	D'20'		;
	SUBWF	TEMP_TMR1L,W	;SUBTRACT FROM TEMP TIMER1 LOW
				;
				;
	BTFSS	STATUS,CARRY	;CARRY SET?
	GOTO	OVERFLOWED	;LONG LOW THEN 3 SLALL PLUSES
	RETURN			;
				;
;*****************************************************************************
;
;******************************************************************************
FIND_START_BIT
;******************************************************************************
IR_HIGH

	BTFSC	PIR1,TMR1IF	;HAS IT OVER FLOWED
	GOTO 	OVERFLOWED	;
				;
	BTFSs	GPIO,IR_IN	;TEST IR IF HIGH
	GOTO	IR_HIGH		;
				;
	BCf	GPIO,LED	;
				;
	MOVF	TMR1L,W		;MOVE TIMER 1 LOW TO W
	MOVWF	TEMP_TMR1L	;STORE IN TEMP TIMER 1 LOW
				;
	CLRF	TMR1L		;RESET TIMER1 LOW
				;	
	MOVF	TMR1H,W		;MOVE TIMER1
	MOVWF	TEMP_TMR1H	;STORE IN TEMP TIMER 1 HIGH 1
				;
	CLRF	TMR1H		;RESET TIMER1 LOW
				;
	BCF	STATUS,CARRY	;CLEAR CARRY
	RRF	TEMP_TMR1H,F	;ROTATE TEMP TIMER1 HIGH (/2)
	RRF	TEMP_TMR1L,F	;ROTATE TEMP TIMER1 LOW (/2)
				;
	RRF	TEMP_TMR1H,F	;ROTATE TEMP TIMER1 HIGH (/2)
	RRF	TEMP_TMR1L,F	;ROTATE TEMP TIMER1 LOW (/2)
				;
	MOVLW	D'100'		;
	SUBWF	TEMP_TMR1L,W	;SUBTRACT FROM TEMP TIMER1 LOW
				;
	BTFSS	STATUS,CARRY	;CARRY SET?
	GOTO	OVERFLOWED	;LONG LOW THEN 3 SLALL PLUSES
				;
				;
				;
	MOVLW	D'30'		;
	SUBWF	TEMP_TMR1L,W	;SUBTRACT FROM TEMP TIMER1 LOW
				;
	BTFSS	STATUS,CARRY	;CARRY SET?
	GOTO	OVERFLOWED	;LONG LOW THEN 3 SLALL PLUSES
				;
				;
IR_LOW_TEMP			;
	BTFSc	PIR1,TMR1IF	;HAS IT OVER FLOWED
	GOTO 	OVERFLOWED	;
	BTFSc	GPIO,IR_IN	;TEST IR IF HIGH
	GOTO	IR_LOW_TEMP	;
				;
	BSf	GPIO,LED	;
				;
	MOVF	TMR1L,W		;MOVE TIMER 1 LOW TO W
	MOVWF	TEMP_TMR1L	;STORE IN TEMP TIMER 1 LOW
				;
	CLRF	TMR1L		;RESET TIMER1 LOW
				;
	MOVF	TMR1H,W		;MOVE TIMER1
	MOVWF	TEMP_TMR1H	;STORE IN TEMP TIMER 1 HIGH 1
				;
	CLRF	TMR1H		;RESET TIMER1 LOW
				;	
	BCF	STATUS,CARRY	;CLEAR CARRY
	RRF	TEMP_TMR1H,F	;ROTATE TEMP TIMER1 HIGH (/2)
	RRF	TEMP_TMR1L,F	;ROTATE TEMP TIMER1 LOW (/2)
				;
	RRF	TEMP_TMR1H,F	;ROTATE TEMP TIMER1 HIGH (/2)
	RRF	TEMP_TMR1L,F	;ROTATE TEMP TIMER1 LOW (/2)
				;
	MOVLW	D'100'		;
	SUBWF	TEMP_TMR1L,W	;SUBTRACT FROM TEMP TIMER1 LOW
				;
	BTFSS	STATUS,CARRY	;CARRY SET?
	GOTO	OVERFLOWED	;LONG LOW THEN 3 SLALL PLUSES
				;
	MOVLW	D'30'		;
	SUBWF	TEMP_TMR1L,W	;SUBTRACT FROM TEMP TIMER1 LOW
				;
	BTFSS	STATUS,CARRY	;CARRY SET?
	GOTO	OVERFLOWED	;LONG LOW THEN 3 SLALL PLUSES
	RETURN			;
;******************************************************************************
;
;******************************************************************************
DELAY_SMALL1
		GOTO $+1
		GOTO $+1
		GOTO $+1
		GOTO $+1
		GOTO $+1
		GOTO $+1
		GOTO $+1
		GOTO $+1
		GOTO $+1
		GOTO $+1
		GOTO $+1
		GOTO $+1
		GOTO $+1
		GOTO $+1
		GOTO $+1
		GOTO $+1
		GOTO $+1
		GOTO $+1
		GOTO $+1
		GOTO $+1
		RETLW	0X00


DELAY_SMALL
		GOTO $+1
		GOTO $+1
		GOTO $+1
		GOTO $+1
		RETLW	0X00


DELAY255	MOVLW	0XFF		;DELAY 255 MS
		GOTO	D0
DELAY100	MOVLW	D'100'		;DELAY 100MS
		GOTO	D0
DELAY50		MOVLW	D'50'		;DELAY 50MS
		GOTO	D0
DELAY20		MOVLW	D'20'		;DELAY 20MS
		GOTO	D0
DELAY5		MOVLW	0X05		;DELAY 5.000 MS (4 MHZ CLOCK)
D0		MOVWF	COUNT1
D1		MOVLW	0XC7
		MOVWF	COUNTA
		MOVLW	0X01
		MOVWF	COUNTB
DELAY_0		DECFSZ	COUNTA, F
		GOTO	$+2
		DECFSZ	COUNTB, F
		GOTO	DELAY_0

		DECFSZ	COUNT1	,F
		GOTO	D1
		RETLW	0X00
;---------------------------------------------------------------------------
;end of Delay routines
;---------------------------------------------------------------------------


;==================================================
SEND_0
	BSF	GPIO,LED		;TURN ON LED
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	BCF	GPIO,LED		;LED
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	RETURN
;==================================================
SEND_1
	BSF	GPIO,LED		;LED
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1

	BCF	GPIO,LED		;LED
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	RETURN
;==================================================
SEND_GAP
	BSF	GPIO,LED		;LED
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1

	BCF	GPIO,LED		;LED
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	RETURN
;==================================================
SEND_GAP1
	BcF	GPIO,LED		;LED
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1

	BsF	GPIO,LED		;LED
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	RETURN
;==================================================
end_pulse_output
	BCF	GPIO,LED
	MOVLW	B'10110101'	;THIS DATA IS HELD IN REVERSE TO NORMAL
	XORWF	BYTE_IN_LOW,W	;
	BTFSC	STATUS,_ZERO	;SAME?
	BSF	GPIO,LED	;
	CALL	DELAY5		;

	BCF	GPIO,LED	;
	MOVLW	B'10101010'	;THIS DATA IS HELD IN REVERSE TO NORMAL
	XORWF	BYTE_IN_HIGH,W	;
	BTFSC	STATUS,_ZERO	;SAME?
	BSF	GPIO,LED	;
	CALL	DELAY5


	BCF	GPIO,LED	;
	MOVLW	B'01010100'	;THIS DATA IS HELD IN REVERSE TO NORMAL
	XORWF	BYTE_IN_HIGHER,W	;
	BTFSC	STATUS,_ZERO	;SAME?
	BSF	GPIO,LED	;
	CALL	DELAY5
	BCF	GPIO,LED
;=========================================
;	FIVE SECOND DELAY
;=========================================
	MOVLW	B'10110101'	;THIS DATA IS HELD IN REVERSE TO NORMAL
	XORWF	BYTE_IN_LOW,W	;
	BTFSS	STATUS,_ZERO	;SAME?
	RETURN

	MOVLW	B'10101010'	;THIS DATA IS HELD IN REVERSE TO NORMAL
	XORWF	BYTE_IN_HIGH,W	;
	BTFSS	STATUS,_ZERO	;SAME?
	RETURN

	MOVLW	B'01010100'	;THIS DATA IS HELD IN REVERSE TO NORMAL
	XORWF	BYTE_IN_HIGHER,W	;
	BTFSS	STATUS,_ZERO	;SAME?
	RETURN
	BSF	GPIO,LED	;

;******************************************************************************
;	BANK1				; BANK1
;                 76543210  
;	MOVLW	B'00010000'		; 5-1 INPUTS GP0 OUTPUT
;	MOVWF	TRISIO			;
;	BANK0	
;******************************************************************************
	BCF	GPIO,1		;TURN ON BUTTON
	CALL DELAY255		;1/4 SEC
	BSF	GPIO,1		;TURN ON BUTTON
	
	CALL DELAY255		;1/4 SEC
	CALL DELAY255		;1/4 SEC
	CALL DELAY255		;1/4 SEC

;******************************************************************************
;	BANK1				; BANK1
;                 76543210  
;	MOVLW	B'00010010'		; 5-1 INPUTS GP0 OUTPUT
;	MOVWF	TRISIO			;
;	BANK0	
;******************************************************************************
	CALL DELAY255		;1/4 SEC	
	CALL DELAY255		;1/4 SEC
	CALL DELAY255		;1/4 SEC
	CALL DELAY255		;1/4 SEC

	CALL DELAY255		;1/4 SEC	
	CALL DELAY255		;1/4 SEC
	CALL DELAY255		;1/4 SEC
	CALL DELAY255		;1/4 SEC

	CALL DELAY255		;1/4 SEC	
	CALL DELAY255		;1/4 SEC
	CALL DELAY255		;1/4 SEC
	CALL DELAY255		;1/4 SEC

	CALL DELAY255		;1/4 SEC	
	CALL DELAY255		;1/4 SEC
	CALL DELAY255		;1/4 SEC
	CALL DELAY255		;1/4 SEC

	BCF	GPIO,LED	;
	BSF	GPIO,1		;CLEAR BUTTON
	RETURN
;******************************************************************************
;	
;******************************************************************************
OVERFLOWED	;LONG LOW THEN 3 SLALL PLUSES
;	CALL	FLASH
	BCF	GPIO,LED		;TURN ON LED
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1

	BSF	GPIO,LED		;TURN ON LED
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	BCF	GPIO,LED		;LED
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
;1
	BSF	GPIO,LED		;LED
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	BCF	GPIO,LED		;LED
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
;2
	BSF	GPIO,LED		;LED
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	BCF	GPIO,LED		;LED
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
;3
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	GOTO	FIND_START1
;******************************************************************************
;
;******************************************************************************
UNDERFLOWED	;LONG LOW 2 SMALL PLUSES
;	CALL	FLASH
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1

	BSF	GPIO,LED		;TURN ON LED
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	BCF	GPIO,LED		;LED
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
;1
	BSF	GPIO,LED		;TURN ON LED
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	BCF	GPIO,LED		;LED
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
;2
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	GOTO	FIND_START1
;******************************************************************************
;
;******************************************************************************

START_OUTPUT
;0
	BSF	GPIO,LED		;TURN ON LED
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	BCF	GPIO,LED		;LED
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
;1
	BSF	GPIO,LED		;LED
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	BCF	GPIO,LED		;LED
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
;2
	BSF	GPIO,LED		;TURN ON LED
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	BCF	GPIO,LED		;LED
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
;3
	BSF	GPIO,LED		;LED
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	BCF	GPIO,LED		;LED
	CALL	DELAY_SMALL1
	CALL	DELAY_SMALL1
	RETURN

;******************************************************************************

	END


